----------------------------------------------------------------------------------
-- Company: fumi2kick
-- Engineer: rerofumi
-- 
-- Create Date:    01:23:33 06/14/2007 
-- Design Name: 
-- Module Name:    v850_video - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity v850_video is
    Port ( CLK : in  STD_LOGIC;
           VOUT1 : out  STD_LOGIC;
           VOUT2 : out  STD_LOGIC;
           CWAIT : in  STD_LOGIC;
           CRD : in  STD_LOGIC;
           CWR0 : in  STD_LOGIC;
           CWR1 : in  STD_LOGIC;
           CD : inout  STD_LOGIC_VECTOR (7 downto 0);
           CA : in  STD_LOGIC_VECTOR (16 downto 0);
           CCLK : in  STD_LOGIC;
           VBLNK : out  STD_LOGIC;
           VENBL : in  STD_LOGIC;
           RE1 : out  STD_LOGIC;
           RE2 : out  STD_LOGIC;
           RG : out  STD_LOGIC;
           RW : out  STD_LOGIC;
           RD : inout  STD_LOGIC_VECTOR (7 downto 0);
           RA : out  STD_LOGIC_VECTOR (16 downto 0));
end v850_video;

architecture Behavioral of v850_video is

  -- component
  component video_bus
    Port ( CA : in  STD_LOGIC_VECTOR (16 downto 0);
           CD : inout  STD_LOGIC_VECTOR (7 downto 0);
           CR : in  STD_LOGIC;
           CW : in  STD_LOGIC;
           CLK : in  STD_LOGIC;
           VENBL : in  STD_LOGIC;
           VBLNK : in  STD_LOGIC;
           BA : in  STD_LOGIC_VECTOR (16 downto 0);
           BD : out  STD_LOGIC_VECTOR (7 downto 0);
           RA : out  STD_LOGIC_VECTOR (16 downto 0);
           RD : inout  STD_LOGIC_VECTOR (7 downto 0);
           RG : out  STD_LOGIC;
           RW : out  STD_LOGIC);
  end component;
  
  component video_crtc
    Port ( BA : out  STD_LOGIC_VECTOR (16 downto 0);
           BD : in  STD_LOGIC_VECTOR (7 downto 0);
           VBLNK : out  STD_LOGIC;
           VBLNK_IN : out  STD_LOGIC;
           CLK : in  STD_LOGIC;
           VOUT1 : out  STD_LOGIC;
           VOUT2 : out  STD_LOGIC);
  end component;

  -- wire
  signal VBLANK : STD_LOGIC;
  signal VBLANK_IN : STD_LOGIC;
  signal DISP_DATA : STD_LOGIC_VECTOR (7 downto 0);
  signal DISP_ADDRESS : STD_LOGIC_VECTOR (16 downto 0);

begin
  ---------------------------------------
  --- wire work
  VBLNK <= VBLANK;

  -- RAM bus arbit
  RAMBUS : video_bus port map (
    CA, CD, CRD, CWR0, CLK, VENBL, VBLANK_IN,
    DISP_ADDRESS, DISP_DATA, RA, RD, RG, RW);
    
  -- CRTC module
  CRTC : video_crtc port map (
    DISP_ADDRESS, DISP_DATA, VBLANK, VBLANK_IN, CLK, VOUT1, VOUT2);

  ---------------------------------------
  -- SRAM enable
  RE1 <= '0';
  RE2 <= '1';


end Behavioral;

