----------------------------------------------------------------------------------
-- Company: fumi2kick
-- Engineer: rerofumi
-- 
-- Create Date:    01:34:13 06/14/2007 
-- Design Name: 
-- Module Name:    video_bus - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity video_bus is
    Port ( CA : in  STD_LOGIC_VECTOR (16 downto 0);
           CD : inout  STD_LOGIC_VECTOR (7 downto 0);
           CR : in  STD_LOGIC;
           CW : in  STD_LOGIC;
           CLK : in  STD_LOGIC;
           VENBL : in  STD_LOGIC;
           VBLNK : in  STD_LOGIC;
           BA : in  STD_LOGIC_VECTOR (16 downto 0);
           BD : out  STD_LOGIC_VECTOR (7 downto 0);
           RA : out  STD_LOGIC_VECTOR (16 downto 0);
           RD : inout  STD_LOGIC_VECTOR (7 downto 0);
           RG : out  STD_LOGIC;
           RW : out  STD_LOGIC);
end video_bus;

architecture Behavioral of video_bus is

begin

  -- bus control
  process(CLK)
  begin
    if VENBL='1' and VBLNK='0' then
      -- CRTC access
      RW <= '1';
      RG <= '0';
      BD <= RD;
      RA <= BA;
      CD <= "ZZZZZZZZ";
    else
      -- enable SRAM access from CPU
      BD <= "00000000";
      RA <= CA;
      RG <= CR;
      RW <= CW;
      if CR='0' and CW='1' then
        CD <= RD;
        RD <= "ZZZZZZZZ";
      elsif CR='1' and CW='0' then
        RD <= CD;
        CD <= "ZZZZZZZZ";
      else
        RD <= "ZZZZZZZZ";
        CD <= "ZZZZZZZZ";
      end if;
    end if; 
  end process;


end Behavioral;

